Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImagePlaneWidget Class Reference

`#include <vtkImagePlaneWidget.h>`

Inheritance diagram for vtkImagePlaneWidget:

[legend]
Collaboration diagram for vtkImagePlaneWidget:

[legend]
List of all members.

## Detailed Description

3D widget for reslicing image data

Date:
  2003/02/04 16:40:13

Revision:
  1.31

This 3D widget defines a plane that can be interactively placed in an image volume. A nice feature of the object is that the vtkImagePlaneWidget, like any 3D widget, will work with the current interactor style. That is, if vtkImagePlaneWidget does not handle an event, then all other registered observers (including the interactor style) have an opportunity to process the event. Otherwise, the vtkImagePlaneWidget will terminate the processing of the event that it handles.

The core functionality of the widget is provided by a vtkImageReslice object which passes its output onto a texture mapping pipeline for fast slicing through volumetric data. See the key methods: GenerateTexturePlane(), UpdateOrigin() and UpdateNormal() for implementation details.

To use this object, just invoke SetInteractor() with the argument of the method a vtkRenderWindowInteractor. You may also wish to invoke "PlaceWidget()" to initially position the widget. If the "i" key (for "interactor") is pressed, the vtkImagePlaneWidget will appear. (See superclass documentation for information about changing this behavior.)

Selecting the widget with the middle mouse button with and without holding the shift or control keys enables complex reslicing capablilites. To facilitate use, a set of 'margins' (left, right, top, bottom) are shown as a set of plane-axes aligned lines, the properties of which can be changed as a group. Without keyboard modifiers: selecting in the middle of the margins enables translation of the plane along its normal. Selecting one of the corners within the margins enables spinning around the plane's normal at its center. Selecting within a margin allows rotating about the center of the plane around an axis aligned with the margin (i.e., selecting left margin enables rotating around the plane's local y-prime axis). With control key modifier: margin selection enables edge translation (i.e., a constrained form of scaling). Selecting within the margins enables translation of the entire plane. With shift key modifier: uniform plane scaling is enabled. Moving the mouse up enlarges the plane while downward movement shrinks it.

Window-level is achieved by using the right mouse button. The left mouse button can be used to query the underlying image data with a snap-to cross-hair cursor. Currently, the nearest point in the input image data to the mouse cursor generates the cross-hairs. With oblique slicing, this behaviour may appear unsatisfactory. Text display of window-level and image coordinates/data values are provided by a text actor/mapper pair. Events that occur outside of the widget (i.e., no part of the widget is picked) are propagated to any other registered obsevers (such as the interaction style). Turn off the widget by pressing the "i" key again (or invoke the Off() method).

The vtkImagePlaneWidget has several methods that can be used in conjunction with other VTK objects. The GetPolyData() method can be used to get the polygonal representation of the plane and can be used as input for other VTK objects. Typical usage of the widget is to make use of the StartInteractionEvent, InteractionEvent, and EndInteractionEvent events. The InteractionEvent is called on mouse motion; the other two events are called on button down and button up (either left or right button).

Some additional features of this class include the ability to control the properties of the widget. You can set the properties of: the selected and unselected representations of the plane's outline; the text actor via its vtkTextProperty; the cross-hair cursor. In addition there are methods to constrain the plane so that it is aligned along the x-y-z axes. Finally, one can specify the degree of interpolation (vtkImageReslice): nearest neighbour, linear, and cubic.

Thanks:
  Thanks to Dean Inglis for developing and contributing this class. Based on the Python SlicePlaneFactory from Atamai, Inc.

Warning:
  Note that handles and plane can be picked even when they are "behind" other actors. This is an intended feature and not a bug.

See also:
  vtk3DWidget vtkBoxWidget vtkLineWidget vtkPlaneWidget vtkPointWidget vtkPolyDataSourceWidget vtkSphereWidget vtkImplicitPlaneWidget

Events:
  vtkCommand::EnableEvent vtkCommand::InteractionEvent vtkCommand::EndInteractionEvent vtkCommand::DisableEvent vtkCommand::StartInteractionEvent

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - dean (67%)
  - Schroeder, Will (23%)

CVS logs (CVSweb):
  - .`h` (`/Hybrid/vtkImagePlaneWidget.h)`
  - .`cxx` (`/Hybrid/vtkImagePlaneWidget.cxx)`

Examples:
  vtkImagePlaneWidget (Examples)

Tests:
  vtkImagePlaneWidget (Tests)

Definition at line 149 of file vtkImagePlaneWidget.h.

## Public Types
typedef vtkPolyDataSourceWidget | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetInput (vtkDataSet *input)
void | GetVector1 (float v1[3])
void | GetVector2 (float v2[3])
int | GetSliceIndex ()
void | SetSliceIndex (int index)
float | GetSlicePosition ()
void | SetSlicePosition (float position)
vtkImageData * | GetResliceOutput ()
void | GetPolyData (vtkPolyData *pd)
vtkPolyDataSource * | GetPolyDataSource ()
void | UpdatePlacement (void)
vtkTexture * | GetTexture ()
vtkImageMapToColors * | GetImageMapToColors ()
void | SetPicker (vtkCellPicker *)
void | GetWindowLevel (float wl[2])
int | GetCursorData (float xyzv[4])
virtual void | SetEnabled (int)
virtual void | PlaceWidget (float bounds[6])
void | PlaceWidget ()
void | PlaceWidget (float xmin, float xmax, float ymin, float ymax, float zmin, float zmax)
void | SetOrigin (float x, float y, float z)
void | SetOrigin (float xyz[3])
float * | GetOrigin ()
void | GetOrigin (float xyz[3])
void | SetPoint1 (float x, float y, float z)
void | SetPoint1 (float xyz[3])
float * | GetPoint1 ()
void | GetPoint1 (float xyz[3])
void | SetPoint2 (float x, float y, float z)
void | SetPoint2 (float xyz[3])
float * | GetPoint2 ()
void | GetPoint2 (float xyz[3])
float * | GetCenter ()
void | GetCenter (float xyz[3])
float * | GetNormal ()
void | GetNormal (float xyz[3])
void | SetResliceInterpolate (int)
virtual int | GetResliceInterpolate ()
void | SetResliceInterpolateToNearestNeighbour ()
void | SetResliceInterpolateToLinear ()
void | SetResliceInterpolateToCubic ()
virtual void | SetRestrictPlaneToVolume (int)
virtual int | GetRestrictPlaneToVolume ()
virtual void | RestrictPlaneToVolumeOn ()
virtual void | RestrictPlaneToVolumeOff ()
virtual void | SetUserControlledLookupTable (int)
virtual int | GetUserControlledLookupTable ()
virtual void | UserControlledLookupTableOn ()
virtual void | UserControlledLookupTableOff ()
virtual void | SetTextureInterpolate (int)
virtual int | GetTextureInterpolate ()
virtual void | TextureInterpolateOn ()
virtual void | TextureInterpolateOff ()
virtual void | SetPlaneProperty (vtkProperty *)
virtual vtkProperty * | GetPlaneProperty ()
virtual void | SetSelectedPlaneProperty (vtkProperty *)
virtual vtkProperty * | GetSelectedPlaneProperty ()
void | SetPlaneOrientation (int)
virtual int | GetPlaneOrientation ()
void | SetPlaneOrientationToXAxes ()
void | SetPlaneOrientationToYAxes ()
void | SetPlaneOrientationToZAxes ()
virtual void | SetLookupTable (vtkLookupTable *)
virtual vtkLookupTable * | GetLookupTable ()
virtual void | SetDisplayText (int)
virtual int | GetDisplayText ()
virtual void | DisplayTextOn ()
virtual void | DisplayTextOff ()
virtual void | SetCursorProperty (vtkProperty *)
virtual vtkProperty * | GetCursorProperty ()
virtual void | SetMarginProperty (vtkProperty *)
virtual vtkProperty * | GetMarginProperty ()
void | SetTextProperty (vtkTextProperty *tprop)
vtkTextProperty * | GetTextProperty ()
virtual void | SetTexturePlaneProperty (vtkProperty *)
virtual vtkProperty * | GetTexturePlaneProperty ()
void | SetInteraction (int interact)
virtual int | GetInteraction ()
virtual void | InteractionOn ()
virtual void | InteractionOff ()
## Static Public Methods
vtkImagePlaneWidget * | New ()
int | IsTypeOf (const char *type)
vtkImagePlaneWidget * | SafeDownCast (vtkObject *o)
## Protected Types
enum | WidgetState { Start = 0, Cursoring, WindowLevelling, Pushing, Spinning, Rotating, Moving, Scaling, Outside }
## Protected Methods
| vtkImagePlaneWidget ()
| ~vtkImagePlaneWidget ()
void | OnMouseMove ()
void | OnLeftButtonDown ()
void | OnLeftButtonUp ()
void | OnMiddleButtonDown ()
void | OnMiddleButtonUp ()
void | OnRightButtonDown ()
void | OnRightButtonUp ()
void | HighlightPlane (int highlight)
void | GeneratePlaneOutline ()
void | BuildRepresentation ()
void | WindowLevel (int X, int Y)
void | Push (double *p1, double *p2)
void | Spin (double *p1, double *p2)
void | Rotate (double *p1, double *p2, double *vpn)
void | Scale (double *p1, double *p2, int X, int Y)
void | Translate (double *p1, double *p2)
vtkLookupTable * | CreateDefaultLookupTable ()
void | CreateDefaultProperties ()
void | UpdateNormal ()
void | UpdateOrigin ()
void | GenerateTexturePlane ()
void | GenerateCursor ()
void | UpdateCursor (int, int)
void | ActivateCursor (int)
void | GenerateText ()
void | ManageTextDisplay ()
void | ActivateText (int)
void | AdjustState ()
void | GenerateMargins ()
void | UpdateMargins ()
void | ActivateMargins (int)
## Static Protected Methods
void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
## Protected Attributes
int | State
int | Interaction
int | PlaneOrientation
int | RestrictPlaneToVolume
float | OriginalWindow
float | OriginalLevel
float | CurrentWindow
float | CurrentLevel
int | ResliceInterpolate
int | TextureInterpolate
int | UserControlledLookupTable
int | DisplayText
vtkPlaneSource * | PlaneSource
float | Normal [3]
vtkPolyData * | PlaneOutlinePolyData
vtkActor * | PlaneOutlineActor
vtkPolyDataMapper * | PlaneOutlineMapper
vtkCellPicker * | PlanePicker
vtkImageData * | ImageData
vtkImageReslice * | Reslice
vtkMatrix4x4 * | ResliceAxes
vtkTransform * | Transform
vtkTextureMapToPlane * | TexturePlaneCoords
vtkDataSetMapper * | TexturePlaneMapper
vtkActor * | TexturePlaneActor
vtkImageMapToColors * | ColorMap
vtkTexture * | Texture
vtkLookupTable * | LookupTable
vtkProperty * | PlaneProperty
vtkProperty * | SelectedPlaneProperty
vtkProperty * | CursorProperty
vtkProperty * | MarginProperty
vtkProperty * | TexturePlaneProperty
vtkPolyData * | CursorPolyData
vtkPolyDataMapper * | CursorMapper
vtkActor * | CursorActor
int | CurrentCursorPosition [3]
float | CurrentImageValue
vtkTextActor * | TextActor
char | TextBuff [128]
float | RotateAxis [3]
float | RadiusVector [3]
vtkPolyData * | MarginPolyData
vtkPolyDataMapper * | MarginMapper
vtkActor * | MarginActor
int | MarginSelectMode

## Member Typedef Documentation

typedef vtkPolyDataSourceWidget vtkImagePlaneWidget::Superclass

| Reimplemented from vtkPolyDataSourceWidget. Definition at line 155 of file vtkImagePlaneWidget.h.

## Member Enumeration Documentation

enum vtkImagePlaneWidget::WidgetState`[protected]`

  | Enumeration values:
  Start |
  Cursoring |
  WindowLevelling |
  Pushing |
  Spinning |
  Rotating |
  Moving |
  Scaling |
  Outside |
Definition at line 389 of file vtkImagePlaneWidget.h.

## Constructor & Destructor Documentation

vtkImagePlaneWidget::vtkImagePlaneWidget | ( |  | ) | `[protected]`

vtkImagePlaneWidget::~vtkImagePlaneWidget | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImagePlaneWidget* vtkImagePlaneWidget::New | ( |  | ) | `[static]`

| Instantiate the object. Reimplemented from vtkObject.

virtual const char* vtkImagePlaneWidget::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataSourceWidget.

int vtkImagePlaneWidget::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSourceWidget.

virtual int vtkImagePlaneWidget::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSourceWidget.

vtkImagePlaneWidget* vtkImagePlaneWidget::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataSourceWidget.

void vtkImagePlaneWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataSourceWidget.

virtual void vtkImagePlaneWidget::SetEnabled | ( | int |  | ) | `[virtual]`

| Methods that satisfy the superclass' API. Implements vtkInteractorObserver.

virtual void vtkImagePlaneWidget::PlaceWidget | ( | float | bounds[6] | ) | `[virtual]`

| Methods that satisfy the superclass' API. Implements vtkPolyDataSourceWidget.

void vtkImagePlaneWidget::PlaceWidget | ( |  | ) | `[inline, virtual]`

| Methods that satisfy the superclass' API. Reimplemented from vtkPolyDataSourceWidget. Definition at line 162 of file vtkImagePlaneWidget.h.

void vtkImagePlaneWidget::PlaceWidget | ( | float | xmin,
|  | float | xmax,
|  | float | ymin,
|  | float | ymax,
|  | float | zmin,
|  | float | zmax
| ) | `[inline]`

| Methods that satisfy the superclass' API. Reimplemented from vtkPolyDataSourceWidget. Definition at line 164 of file vtkImagePlaneWidget.h.

void vtkImagePlaneWidget::SetInput | ( | vtkDataSet * | input | ) | `[virtual]`

| Set the vtkImageData* input for the vtkImageReslice. Reimplemented from vtk3DWidget.

void vtkImagePlaneWidget::SetOrigin | ( | float | x,
|  | float | y,
|  | float | z
| ) |

| Set/Get the origin of the plane.

void vtkImagePlaneWidget::SetOrigin | ( | float | xyz[3] | ) |

| Set/Get the origin of the plane.

float* vtkImagePlaneWidget::GetOrigin | ( |  | ) |

| Set/Get the origin of the plane.

void vtkImagePlaneWidget::GetOrigin | ( | float | xyz[3] | ) |

| Set/Get the origin of the plane.

void vtkImagePlaneWidget::SetPoint1 | ( | float | x,
|  | float | y,
|  | float | z
| ) |

| Set/Get the position of the point defining the first axis of the plane.

void vtkImagePlaneWidget::SetPoint1 | ( | float | xyz[3] | ) |

| Set/Get the position of the point defining the first axis of the plane.

float* vtkImagePlaneWidget::GetPoint1 | ( |  | ) |

| Set/Get the position of the point defining the first axis of the plane.

void vtkImagePlaneWidget::GetPoint1 | ( | float | xyz[3] | ) |

| Set/Get the position of the point defining the first axis of the plane.

void vtkImagePlaneWidget::SetPoint2 | ( | float | x,
|  | float | y,
|  | float | z
| ) |

| Set/Get the position of the point defining the second axis of the plane.

void vtkImagePlaneWidget::SetPoint2 | ( | float | xyz[3] | ) |

| Set/Get the position of the point defining the second axis of the plane.

float* vtkImagePlaneWidget::GetPoint2 | ( |  | ) |

| Set/Get the position of the point defining the second axis of the plane.

void vtkImagePlaneWidget::GetPoint2 | ( | float | xyz[3] | ) |

| Set/Get the position of the point defining the second axis of the plane.

float* vtkImagePlaneWidget::GetCenter | ( |  | ) |

| Get the center of the plane.

void vtkImagePlaneWidget::GetCenter | ( | float | xyz[3] | ) |

| Get the center of the plane.

float* vtkImagePlaneWidget::GetNormal | ( |  | ) |

| Get the normal to the plane.

void vtkImagePlaneWidget::GetNormal | ( | float | xyz[3] | ) |

| Get the normal to the plane.

void vtkImagePlaneWidget::GetVector1 | ( | float | v1[3] | ) |

| Get the vector from the plane origin to point1.

void vtkImagePlaneWidget::GetVector2 | ( | float | v2[3] | ) |

| Get the vector from the plane origin to point2.

int vtkImagePlaneWidget::GetSliceIndex | ( |  | ) |

| Get the slice position in terms of the data extent.

void vtkImagePlaneWidget::SetSliceIndex | ( | int | index | ) |

| Set the slice position in terms of the data extent.

float vtkImagePlaneWidget::GetSlicePosition | ( |  | ) |

| Get the position of the slice along its normal.

void vtkImagePlaneWidget::SetSlicePosition | ( | float | position | ) |

| Set the position of the slice along its normal.

void vtkImagePlaneWidget::SetResliceInterpolate | ( | int |  | ) |

| Set the interpolation to use when texturing the plane.

virtual int vtkImagePlaneWidget::GetResliceInterpolate | ( |  | ) | `[virtual]`

| Set the interpolation to use when texturing the plane.

void vtkImagePlaneWidget::SetResliceInterpolateToNearestNeighbour | ( |  | ) | `[inline]`

| Set the interpolation to use when texturing the plane. Definition at line 232 of file vtkImagePlaneWidget.h. References VTK_NEAREST_RESLICE.

void vtkImagePlaneWidget::SetResliceInterpolateToLinear | ( |  | ) | `[inline]`

| Set the interpolation to use when texturing the plane. Definition at line 234 of file vtkImagePlaneWidget.h. References VTK_LINEAR_RESLICE.

void vtkImagePlaneWidget::SetResliceInterpolateToCubic | ( |  | ) | `[inline]`

| Set the interpolation to use when texturing the plane. Definition at line 236 of file vtkImagePlaneWidget.h. References VTK_CUBIC_RESLICE.

vtkImageData* vtkImagePlaneWidget::GetResliceOutput | ( |  | ) |

| Convenience method to get the vtkImageReslice output.

virtual void vtkImagePlaneWidget::SetRestrictPlaneToVolume | ( | int |  | ) | `[virtual]`

| Make sure that the plane remains within the volume. Default is On.

virtual int vtkImagePlaneWidget::GetRestrictPlaneToVolume | ( |  | ) | `[virtual]`

| Make sure that the plane remains within the volume. Default is On.

virtual void vtkImagePlaneWidget::RestrictPlaneToVolumeOn | ( |  | ) | `[virtual]`

| Make sure that the plane remains within the volume. Default is On.

virtual void vtkImagePlaneWidget::RestrictPlaneToVolumeOff | ( |  | ) | `[virtual]`

| Make sure that the plane remains within the volume. Default is On.

virtual void vtkImagePlaneWidget::SetUserControlledLookupTable | ( | int |  | ) | `[virtual]`

| Let the user control the lookup table. NOTE: apply this method BEFORE applying the SetLookupTable method. Default is Off.

virtual int vtkImagePlaneWidget::GetUserControlledLookupTable | ( |  | ) | `[virtual]`

| Let the user control the lookup table. NOTE: apply this method BEFORE applying the SetLookupTable method. Default is Off.

virtual void vtkImagePlaneWidget::UserControlledLookupTableOn | ( |  | ) | `[virtual]`

| Let the user control the lookup table. NOTE: apply this method BEFORE applying the SetLookupTable method. Default is Off.

virtual void vtkImagePlaneWidget::UserControlledLookupTableOff | ( |  | ) | `[virtual]`

| Let the user control the lookup table. NOTE: apply this method BEFORE applying the SetLookupTable method. Default is Off.

virtual void vtkImagePlaneWidget::SetTextureInterpolate | ( | int |  | ) | `[virtual]`

| Specify whether to interpolate the texture or not. When off, the reslice interpolation is nearest neighbour regardless of how the interpolation is set through the API. Set before setting the vtkImageData imput. Default is On.

virtual int vtkImagePlaneWidget::GetTextureInterpolate | ( |  | ) | `[virtual]`

| Specify whether to interpolate the texture or not. When off, the reslice interpolation is nearest neighbour regardless of how the interpolation is set through the API. Set before setting the vtkImageData imput. Default is On.

virtual void vtkImagePlaneWidget::TextureInterpolateOn | ( |  | ) | `[virtual]`

| Specify whether to interpolate the texture or not. When off, the reslice interpolation is nearest neighbour regardless of how the interpolation is set through the API. Set before setting the vtkImageData imput. Default is On.

virtual void vtkImagePlaneWidget::TextureInterpolateOff | ( |  | ) | `[virtual]`

| Specify whether to interpolate the texture or not. When off, the reslice interpolation is nearest neighbour regardless of how the interpolation is set through the API. Set before setting the vtkImageData imput. Default is On.

void vtkImagePlaneWidget::GetPolyData | ( | vtkPolyData * | pd | ) |

| Grab the polydata (including points) that defines the plane. The polydata consists of (res+1)*(res+1) points, and res*res quadrilateral polygons, where res is the resolution of the plane. These point values are guaranteed to be up-to-date when either the InteractionEvent or EndInteraction events are invoked. The user provides the vtkPolyData and the points and polyplane are added to it.

vtkPolyDataSource* vtkImagePlaneWidget::GetPolyDataSource | ( |  | ) | `[virtual]`

| Satisfies superclass API. This returns a pointer to the underlying PolyData. Make changes to this before calling the initial PlaceWidget() to have the initial placement follow suit. Or, make changes after the widget has been initialised and call UpdatePlacement() to realise. Implements vtkPolyDataSourceWidget.

void vtkImagePlaneWidget::UpdatePlacement | ( | void |  | ) | `[virtual]`

| Satisfies superclass API. This will change the state of the widget to match changes that have been made to the underlying PolyDataSource Implements vtkPolyDataSourceWidget.

vtkTexture* vtkImagePlaneWidget::GetTexture | ( |  | ) |

| Convenience method to get the texture used by this widget. This can be used in external slice viewers.

vtkImageMapToColors* vtkImagePlaneWidget::GetImageMapToColors | ( |  | ) |

| Convenience method to get the vtkImageMapToColors filter used by this widget. The user can properly render other transparent actors in a scene by calling the filter's SetOuputFormatToRGB and PassAlphaToOutputOff.

virtual void vtkImagePlaneWidget::SetPlaneProperty | ( | vtkProperty * |  | ) | `[virtual]`

| Set/Get the plane's outline properties. The properties of the plane's outline when selected and unselected can be manipulated.

virtual vtkProperty* vtkImagePlaneWidget::GetPlaneProperty | ( |  | ) | `[virtual]`

| Set/Get the plane's outline properties. The properties of the plane's outline when selected and unselected can be manipulated.

virtual void vtkImagePlaneWidget::SetSelectedPlaneProperty | ( | vtkProperty * |  | ) | `[virtual]`

| Set/Get the plane's outline properties. The properties of the plane's outline when selected and unselected can be manipulated.

virtual vtkProperty* vtkImagePlaneWidget::GetSelectedPlaneProperty | ( |  | ) | `[virtual]`

| Set/Get the plane's outline properties. The properties of the plane's outline when selected and unselected can be manipulated.

void vtkImagePlaneWidget::SetPlaneOrientation | ( | int |  | ) |

| Convenience method sets the plane orientation normal to the x, y, or z axes. Default is XAxes (0).

virtual int vtkImagePlaneWidget::GetPlaneOrientation | ( |  | ) | `[virtual]`

| Convenience method sets the plane orientation normal to the x, y, or z axes. Default is XAxes (0).

void vtkImagePlaneWidget::SetPlaneOrientationToXAxes | ( |  | ) | `[inline]`

| Convenience method sets the plane orientation normal to the x, y, or z axes. Default is XAxes (0). Definition at line 312 of file vtkImagePlaneWidget.h.

void vtkImagePlaneWidget::SetPlaneOrientationToYAxes | ( |  | ) | `[inline]`

| Convenience method sets the plane orientation normal to the x, y, or z axes. Default is XAxes (0). Definition at line 314 of file vtkImagePlaneWidget.h.

void vtkImagePlaneWidget::SetPlaneOrientationToZAxes | ( |  | ) | `[inline]`

| Convenience method sets the plane orientation normal to the x, y, or z axes. Default is XAxes (0). Definition at line 316 of file vtkImagePlaneWidget.h.

void vtkImagePlaneWidget::SetPicker | ( | vtkCellPicker * |  | ) |

| Set the internal picker to one defined by the user. In this way, a set of three orthogonal planes can share the same picker so that picking is performed correctly. The default internal picker can be re-set/allocated by setting to 0 (NULL).

virtual void vtkImagePlaneWidget::SetLookupTable | ( | vtkLookupTable * |  | ) | `[virtual]`

| Set/Get the internal lookuptable (lut) to one defined by the user, or, alternatively, to the lut of another vtkImgePlaneWidget. In this way, a set of three orthogonal planes can share the same lut so that window-levelling is performed uniformly among planes. The default internal lut can be re- set/allocated by setting to 0 (NULL).

virtual vtkLookupTable* vtkImagePlaneWidget::GetLookupTable | ( |  | ) | `[virtual]`

| Set/Get the internal lookuptable (lut) to one defined by the user, or, alternatively, to the lut of another vtkImgePlaneWidget. In this way, a set of three orthogonal planes can share the same lut so that window-levelling is performed uniformly among planes. The default internal lut can be re- set/allocated by setting to 0 (NULL).

virtual void vtkImagePlaneWidget::SetDisplayText | ( | int |  | ) | `[virtual]`

| Enable/disable text display of window-level, image coords and values in a render window.

virtual int vtkImagePlaneWidget::GetDisplayText | ( |  | ) | `[virtual]`

| Enable/disable text display of window-level, image coords and values in a render window.

virtual void vtkImagePlaneWidget::DisplayTextOn | ( |  | ) | `[virtual]`

| Enable/disable text display of window-level, image coords and values in a render window.

virtual void vtkImagePlaneWidget::DisplayTextOff | ( |  | ) | `[virtual]`

| Enable/disable text display of window-level, image coords and values in a render window.

virtual void vtkImagePlaneWidget::SetCursorProperty | ( | vtkProperty * |  | ) | `[virtual]`

| Set the properties of the cross-hair cursor.

virtual vtkProperty* vtkImagePlaneWidget::GetCursorProperty | ( |  | ) | `[virtual]`

| Set the properties of the cross-hair cursor.

virtual void vtkImagePlaneWidget::SetMarginProperty | ( | vtkProperty * |  | ) | `[virtual]`

| Set the properties of the margins.

virtual vtkProperty* vtkImagePlaneWidget::GetMarginProperty | ( |  | ) | `[virtual]`

| Set the properties of the margins.

void vtkImagePlaneWidget::SetTextProperty | ( | vtkTextProperty * | tprop | ) |

| Set/Get the text property for the image data and window-level annotation.

vtkTextProperty* vtkImagePlaneWidget::GetTextProperty | ( |  | ) |

| Set/Get the text property for the image data and window-level annotation.

virtual void vtkImagePlaneWidget::SetTexturePlaneProperty | ( | vtkProperty * |  | ) | `[virtual]`

| Set/Get the property for the resliced image.

virtual vtkProperty* vtkImagePlaneWidget::GetTexturePlaneProperty | ( |  | ) | `[virtual]`

| Set/Get the property for the resliced image.

void vtkImagePlaneWidget::GetWindowLevel | ( | float | wl[2] | ) |

| Get the current window and level values.

int vtkImagePlaneWidget::GetCursorData | ( | float | xyzv[4] | ) |

| Get the image coordinate position and voxel value. Currently only supports single component image data.

void vtkImagePlaneWidget::SetInteraction | ( | int | interact | ) |

| Enable/disable mouse interaction so the widget remains on display.

virtual int vtkImagePlaneWidget::GetInteraction | ( |  | ) | `[virtual]`

| Enable/disable mouse interaction so the widget remains on display.

virtual void vtkImagePlaneWidget::InteractionOn | ( |  | ) | `[virtual]`

| Enable/disable mouse interaction so the widget remains on display.

virtual void vtkImagePlaneWidget::InteractionOff | ( |  | ) | `[virtual]`

| Enable/disable mouse interaction so the widget remains on display.

void vtkImagePlaneWidget::ProcessEvents | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) | `[static, protected]`

| Handles the char widget activation event. Also handles the delete event. Reimplemented from vtkInteractorObserver.

void vtkImagePlaneWidget::OnMouseMove | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnLeftButtonDown | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnLeftButtonUp | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnMiddleButtonDown | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnMiddleButtonUp | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnRightButtonDown | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::OnRightButtonUp | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::HighlightPlane | ( | int | highlight | ) | `[protected]`

void vtkImagePlaneWidget::GeneratePlaneOutline | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::BuildRepresentation | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::WindowLevel | ( | int | X,
|  | int | Y
| ) | `[protected]`

void vtkImagePlaneWidget::Push | ( | double * | p1,
|  | double * | p2
| ) | `[protected]`

void vtkImagePlaneWidget::Spin | ( | double * | p1,
|  | double * | p2
| ) | `[protected]`

void vtkImagePlaneWidget::Rotate | ( | double * | p1,
|  | double * | p2,
|  | double * | vpn
| ) | `[protected]`

void vtkImagePlaneWidget::Scale | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) | `[protected]`

void vtkImagePlaneWidget::Translate | ( | double * | p1,
|  | double * | p2
| ) | `[protected]`

vtkLookupTable* vtkImagePlaneWidget::CreateDefaultLookupTable | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::CreateDefaultProperties | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::UpdateNormal | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::UpdateOrigin | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::GenerateTexturePlane | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::GenerateCursor | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::UpdateCursor | ( | int | ,
|  | int |
| ) | `[protected]`

void vtkImagePlaneWidget::ActivateCursor | ( | int |  | ) | `[protected]`

void vtkImagePlaneWidget::GenerateText | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::ManageTextDisplay | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::ActivateText | ( | int |  | ) | `[protected]`

void vtkImagePlaneWidget::AdjustState | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::GenerateMargins | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::UpdateMargins | ( |  | ) | `[protected]`

void vtkImagePlaneWidget::ActivateMargins | ( | int |  | ) | `[protected]`

## Member Data Documentation

int vtkImagePlaneWidget::State`[protected]`

| Definition at line 388 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::Interaction`[protected]`

| Definition at line 419 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::PlaneOrientation`[protected]`

| Definition at line 420 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::RestrictPlaneToVolume`[protected]`

| Definition at line 421 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::OriginalWindow`[protected]`

| Definition at line 422 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::OriginalLevel`[protected]`

| Definition at line 423 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::CurrentWindow`[protected]`

| Definition at line 424 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::CurrentLevel`[protected]`

| Definition at line 425 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::ResliceInterpolate`[protected]`

| Definition at line 426 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::TextureInterpolate`[protected]`

| Definition at line 427 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::UserControlledLookupTable`[protected]`

| Definition at line 428 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::DisplayText`[protected]`

| Definition at line 429 of file vtkImagePlaneWidget.h.

vtkPlaneSource* vtkImagePlaneWidget::PlaneSource`[protected]`

| Definition at line 432 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::Normal[3]`[protected]`

| Definition at line 433 of file vtkImagePlaneWidget.h.

vtkPolyData* vtkImagePlaneWidget::PlaneOutlinePolyData`[protected]`

| Definition at line 434 of file vtkImagePlaneWidget.h.

vtkActor* vtkImagePlaneWidget::PlaneOutlineActor`[protected]`

| Definition at line 435 of file vtkImagePlaneWidget.h.

vtkPolyDataMapper* vtkImagePlaneWidget::PlaneOutlineMapper`[protected]`

| Definition at line 436 of file vtkImagePlaneWidget.h.

vtkCellPicker* vtkImagePlaneWidget::PlanePicker`[protected]`

| Definition at line 444 of file vtkImagePlaneWidget.h.

vtkImageData* vtkImagePlaneWidget::ImageData`[protected]`

| Definition at line 454 of file vtkImagePlaneWidget.h.

vtkImageReslice* vtkImagePlaneWidget::Reslice`[protected]`

| Definition at line 455 of file vtkImagePlaneWidget.h.

vtkMatrix4x4* vtkImagePlaneWidget::ResliceAxes`[protected]`

| Definition at line 456 of file vtkImagePlaneWidget.h.

vtkTransform* vtkImagePlaneWidget::Transform`[protected]`

| Definition at line 457 of file vtkImagePlaneWidget.h.

vtkTextureMapToPlane* vtkImagePlaneWidget::TexturePlaneCoords`[protected]`

| Definition at line 458 of file vtkImagePlaneWidget.h.

vtkDataSetMapper* vtkImagePlaneWidget::TexturePlaneMapper`[protected]`

| Definition at line 459 of file vtkImagePlaneWidget.h.

vtkActor* vtkImagePlaneWidget::TexturePlaneActor`[protected]`

| Definition at line 460 of file vtkImagePlaneWidget.h.

vtkImageMapToColors* vtkImagePlaneWidget::ColorMap`[protected]`

| Definition at line 461 of file vtkImagePlaneWidget.h.

vtkTexture* vtkImagePlaneWidget::Texture`[protected]`

| Definition at line 462 of file vtkImagePlaneWidget.h.

vtkLookupTable* vtkImagePlaneWidget::LookupTable`[protected]`

| Definition at line 463 of file vtkImagePlaneWidget.h.

vtkProperty* vtkImagePlaneWidget::PlaneProperty`[protected]`

| Definition at line 470 of file vtkImagePlaneWidget.h.

vtkProperty* vtkImagePlaneWidget::SelectedPlaneProperty`[protected]`

| Definition at line 471 of file vtkImagePlaneWidget.h.

vtkProperty* vtkImagePlaneWidget::CursorProperty`[protected]`

| Definition at line 472 of file vtkImagePlaneWidget.h.

vtkProperty* vtkImagePlaneWidget::MarginProperty`[protected]`

| Definition at line 473 of file vtkImagePlaneWidget.h.

vtkProperty* vtkImagePlaneWidget::TexturePlaneProperty`[protected]`

| Definition at line 474 of file vtkImagePlaneWidget.h.

vtkPolyData* vtkImagePlaneWidget::CursorPolyData`[protected]`

| Definition at line 483 of file vtkImagePlaneWidget.h.

vtkPolyDataMapper* vtkImagePlaneWidget::CursorMapper`[protected]`

| Definition at line 484 of file vtkImagePlaneWidget.h.

vtkActor* vtkImagePlaneWidget::CursorActor`[protected]`

| Definition at line 485 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::CurrentCursorPosition[3]`[protected]`

| Definition at line 486 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::CurrentImageValue`[protected]`

| Definition at line 487 of file vtkImagePlaneWidget.h.

vtkTextActor* vtkImagePlaneWidget::TextActor`[protected]`

| Definition at line 493 of file vtkImagePlaneWidget.h.

char vtkImagePlaneWidget::TextBuff[128]`[protected]`

| Definition at line 494 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::RotateAxis[3]`[protected]`

| Definition at line 500 of file vtkImagePlaneWidget.h.

float vtkImagePlaneWidget::RadiusVector[3]`[protected]`

| Definition at line 501 of file vtkImagePlaneWidget.h.

vtkPolyData* vtkImagePlaneWidget::MarginPolyData`[protected]`

| Definition at line 505 of file vtkImagePlaneWidget.h.

vtkPolyDataMapper* vtkImagePlaneWidget::MarginMapper`[protected]`

| Definition at line 506 of file vtkImagePlaneWidget.h.

vtkActor* vtkImagePlaneWidget::MarginActor`[protected]`

| Definition at line 507 of file vtkImagePlaneWidget.h.

int vtkImagePlaneWidget::MarginSelectMode`[protected]`

| Definition at line 508 of file vtkImagePlaneWidget.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkImagePlaneWidget.h